#include "stdafx.h"
#include "Principal.h"
#include "Windows.h"

Principal::Principal()
{
    SYSTEMTIME st;
    GetSystemTime(&st);
    //printf("Year:%d\nMonth:%d\nDate:%d\nHour:%d\nMin:%d\nSecond:% d\n" ,st.wYear,st.wMonth,st.wDay,st.wHour,st.wMinute,st.wSecond);

    diaAtual = st.wMonth;
	mesAtual = st.wDay;
	anoAtual = st.wYear;
    Inicializa ( ); 
}


void Principal::Inicializa ( )
{   
	InicializaAlunos ( );
    InicializaUnivesidades ( );
    InicializaDepartamentos ( );
    InicializaProfessores ( );
    InicializaDisciplinas ( );
}

void Principal::InicializaAlunos()
{ 
	AAA.setNome	("AAA");
	BBB.setNome	("BBB");
	CCC.setNome	("CCC");
	DDD.setNome	("DDD");
	EEE.setNome	("EEE");
}

void Principal::InicializaUnivesidades ( )
{  
    // Registro do(s) nome(s) da(s) universidade(s)
    UTFPR.setNome     ( "UTFPR"		);
	LUniversidades.incluaUniversidade( &UTFPR );

    Princeton.setNome ( "Princeton" );
	LUniversidades.incluaUniversidade( &Princeton );

    Cambridge.setNome ( "Cambridge" );
	LUniversidades.incluaUniversidade( &Cambridge );
}

void Principal::InicializaDepartamentos ( )
{ 
    // Registro do(s) nome(s) do(s) departamento(s)
    EletronicaUTFPR.setNome		( "Eletronica UTFPR" );
	MatematicaUTFPR.setNome		( "Matematica UTFPR" );
    FisicaUTFPR.setNome			( "Fisica UTFPR" );
    MatematicaPrinceton.setNome ( "Matematica Princeton" );
    FisicaPrinceton.setNome		( "Fisica Pirnceton" );
    MatematicaCambridge.setNome ( "Matematica Cambridge" );
    FisicaCambridge.setNome		( "Fisica Cambridge" );   

	LDepartamentos.incluaDepartamento(&EletronicaUTFPR);
	LDepartamentos.incluaDepartamento(&MatematicaUTFPR);
	LDepartamentos.incluaDepartamento(&FisicaUTFPR);
	LDepartamentos.incluaDepartamento(&MatematicaPrinceton);
	LDepartamentos.incluaDepartamento(&FisicaPrinceton);
	LDepartamentos.incluaDepartamento(&MatematicaCambridge);
	LDepartamentos.incluaDepartamento(&FisicaCambridge);
     
    // "Agregao" do(s) Departamento(s) a(s) Universidade(s).
    UTFPR.incluaDepartamento		( &EletronicaUTFPR );
    UTFPR.incluaDepartamento		( &MatematicaUTFPR );
    UTFPR.incluaDepartamento		( &FisicaUTFPR );

    Princeton.incluaDepartamento	( &MatematicaPrinceton );
    Princeton.incluaDepartamento	( &FisicaPrinceton );
    Cambridge.incluaDepartamento	( &MatematicaCambridge );
    Cambridge.incluaDepartamento	( &FisicaCambridge );
}

void Principal::InicializaProfessores ( )
{   

    // Inicializao do(s) ojeto(s) da classe Professor
    Simao.Inicializa	( 3, 10, 1976, "Jean Simo" );
    Einstein.Inicializa ( 14, 3, 1879, "Albert Einstein" );
    Newton.Inicializa	( 4, 1, 1643, "Isaac Newton" );

     // "Filiao" a universidade.
    Simao.setUnivFiliado	( &UTFPR );
    Einstein.setUnivFiliado ( &Princeton );
    Newton.setUnivFiliado	( &Cambridge );

    // Area de Conhecimento.
    // Simao.setDominio		( "Computao );
    // Einstein.setDominio	( "Fsica" );
    // Newton.setDominio	( "Matemtica-Fsica" );

    // "Filiao" ao departamento.
    Simao.setDepartamento	( &EletronicaUTFPR );
    Einstein.setDepartamento( &FisicaPrinceton );
    Newton.setDepartamento	( &MatematicaCambridge );
 }

void Principal::InicializaDisciplinas ( )
{
    Computacao1_2006.setNome	( "Computacao I 2006" );
    Introd_Alg_2007.setNome		( "Introducao de Algoritmos de Programacao 2007" );
	Computacao2_2007.setNome	( "Computao II" );
	Metodos2_2007.setNome		( "Mtodos II" );

	LDisciplinas.incluaDisciplina(&Computacao1_2006);
	LDisciplinas.incluaDisciplina(&Introd_Alg_2007);
	LDisciplinas.incluaDisciplina(&Computacao2_2007);
	LDisciplinas.incluaDisciplina(&Metodos2_2007);

    Computacao1_2006.setDepartamento  ( &EletronicaUTFPR );
    Introd_Alg_2007.setDepartamento	  ( &EletronicaUTFPR );
    Computacao2_2007.setDepartamento  ( &EletronicaUTFPR );
    Metodos2_2007.setDepartamento     ( &EletronicaUTFPR );

    Metodos2_2007.incluaAluno ( &AAA );
    Metodos2_2007.incluaAluno ( &BBB );
    Metodos2_2007.incluaAluno ( &CCC );
    Metodos2_2007.incluaAluno ( &DDD );
    Metodos2_2007.incluaAluno ( &EEE );

	Computacao2_2007.incluaAluno ( &AAA );
    Computacao2_2007.incluaAluno ( &EEE );
    Computacao2_2007.incluaAluno ( &DDD );
}

void Principal::CalcIdadeProfs ( )
{
    // Clculo da idade.
    Simao.Calc_Idade    ( diaAtual, mesAtual, anoAtual );
    Einstein.Calc_Idade ( diaAtual, mesAtual, anoAtual );
    Newton.Calc_Idade	( diaAtual, mesAtual, anoAtual );
    printf ("\n");
}

void Principal::UnivOndeProfsTrabalham ( )
{
    // Universidade que a Pessoa trabalha.
    Simao.OndeTrabalho ( );
    Einstein.OndeTrabalho ( );
    Newton.OndeTrabalho ( );
    
	cout << endl;
}

void Principal::DepOndeProfsTrabalham ( )
{
    // Departamento que a Pessoa trabalha.
    Simao.QualDepartamentoTrabalho ( );
    Einstein.QualDepartamentoTrabalho ( );
    Newton.QualDepartamentoTrabalho ( );
    //printf ( "\n" );
	cout << endl;
}

void Principal::ListeDiscDeptos()
{
    EletronicaUTFPR.listeDisciplinas();
 	cout << endl;
}

void Principal::ListeAlunosDisc()
{
    Metodos2_2007.listeAlunos();
    cout << endl;

    Computacao2_2007.listeAlunos();  
    cout << endl;

	//Metodos2_2007.listeAlunos2();
    //cout << endl;
}

void Principal::Executar()
{
    //CalcIdadeProfs();
    //UnivOndeProfsTrabalham();
    //DepOndeProfsTrabalham();
	//ListeDiscDeptos();
    //ListeAlunosDisc();
	Menu();
}

void Principal::CadDisciplina()
{

}

void Principal::CadDepartamento()
{
    char nomeUniversidade[150];
	char nomeDepartamento[150];
	Universidade* univ;
	Departamento* depart;

	cout << "Qual o nome da universidade do departamento" << endl;
	cin  >> nomeUniversidade;

	univ = LUniversidades.localizar(nomeUniversidade);
	
	if ( univ != NULL )
	{
		cout << "Qual o nome do departamento" << endl;
		cin >> nomeDepartamento;
	    depart = new Departamento();
		depart->setNome(nomeDepartamento);
		LDepartamentos.incluaDepartamento(depart);
		LUniversidades.incluaUniversidade(univ);
	}
	else
	{
		cout << "Universidade inexistente." << endl;
	}
}

void Principal::CadUniversidade()
{
    char nomeUniversidade[150];
	Universidade* univ;

	cout << "Qual o nome da universidade" << endl;
	cin  >> nomeUniversidade;

    univ = new Universidade();
	univ->setNome(nomeUniversidade);

	LUniversidades.incluaUniversidade(univ);
}

void Principal::MenuCad()
{
    int op = -1;

    while (op != 4)
    {
		system("cls");
        cout << "  Informe sua opo:    "			<< endl;
        cout << "  1 - Cadastrar Disciplina.  "		<< endl;
        cout << "  2 - Cadastrar Departamentos. "	<< endl;
        cout << "  3 - Cadastrar Universidade. "	<< endl;
        cout << "  4  Sair. "						<< endl;
        cin >> op;

        switch (op)
        {
            case 1 :{ CadDisciplina ();	 }
                break;

            case 2: { CadDepartamento(); }
				break;

			case 3:	{ CadUniversidade(); }
				break;

            case 4:	{ cout << " FIM " << endl; }
                break;

            default:{                      
					  cout << "Opo Invlida - Pressione uma tecla." << endl;
					  getchar();
				    }
        }
    }
}

void Principal::MenuExe()
{
    int op = -1;
    
    while (op != 4)
    {
		system("cls");
        cout << "  Informe sua opo:		"	<< endl;
        cout << "  1 - Listar Disciplinas.  "	<< endl;
        cout << "  2 - Listar Departamentos."	<< endl;
        cout << "  3 - Listar Universidade. "	<< endl;
        cout << "  4  Sair. "					<< endl;
        cin >> op;

        switch (op)
        {
			case 1:  { 
					   LDisciplinas.listeDisciplinas(); getchar();
					   fflush(stdin);
					   getchar(); 	
					 }
                break;
			case 2:  { 
				       LDepartamentos.listeDepartamentos(); getchar();
					   fflush(stdin);
					   getchar(); 
					 }
				break;
			case 3:  { 
				       LUniversidades.listeUniversidades(); 
				       fflush(stdin);
					   getchar();
					 }
				break;
            case 4:  { cout << " FIM " << endl; }
                break;
            default: { 
					   cout << "Opo Invlida - Pressione uma tecla." << endl;
					   getchar(); 
					 }
        }
    }
}

void Principal::Menu()
{
	int op = -1;
    
    while (op != 3)
    {
		system("cls");
        cout << "  Informe sua opo:"	<< endl;
        cout << "  1 - Cadastrar.	 "	<< endl;
        cout << "  2 - Executar.	 "	<< endl;
        cout << "  3  Sair.		 "	<< endl;
        cin >> op;

        switch (op)
        {
            case 1: { MenuCad(); }
                break;
            case 2: { MenuExe(); }
				break;
			case 3: { cout << " FIM " << endl; }
                break;
            default: { cout << "Opo Invlida - Pressione uma tecla." << endl;
					   getchar(); }
        }
    }	
}
